]> git.ipfire.org Git - thirdparty/git.git/blame - git-submodule.sh
git-add--interactive.perl: Remove two unused variables
[thirdparty/git.git] / git-submodule.sh
CommitLineData
70c7ac22
LH
1#!/bin/sh
2#
ecda0723 3# git-submodules.sh: add, init, update or list git submodules
70c7ac22
LH
4#
5# Copyright (c) 2007 Lars Hjemli
6
1d5bec8b 7dashless=$(basename "$0" | sed -e 's/-/ /')
d27b876b 8USAGE="[--quiet] add [-b branch] [-f|--force] [--reference <repository>] [--] <repository> [<path>]
64b19ffe 9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
1d5bec8b 10 or: $dashless [--quiet] init [--] [<path>...]
9db31bdf 11 or: $dashless [--quiet] update [--init] [-N|--no-fetch] [-f|--force] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
adc54235 12 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
15fc56a8 13 or: $dashless [--quiet] foreach [--recursive] <command>
1d5bec8b 14 or: $dashless [--quiet] sync [--] [<path>...]"
8f321a39 15OPTIONS_SPEC=
70c7ac22 16. git-sh-setup
d0ad8251 17. git-sh-i18n
98fcf840 18. git-parse-remote
70c7ac22
LH
19require_work_tree
20
5c08dbbd 21command=
ecda0723 22branch=
d27b876b 23force=
d92a3959 24reference=
70c7ac22 25cached=
48bb3033
GP
26recursive=
27init=
1c244f6e 28files=
31ca3ac3 29nofetch=
32948425 30update=
15fc56a8 31prefix=
70c7ac22 32
f31a522a
ML
33# Resolve relative url by appending to parent's url
34resolve_relative_url ()
35{
98fcf840 36 remote=$(get_default_remote)
8e7e6f39 37 remoteurl=$(git config "remote.$remote.url") ||
4d689320 38 remoteurl=$(pwd) # the repository is its own authoritative upstream
f31a522a 39 url="$1"
99b120af 40 remoteurl=${remoteurl%/}
ea640cc6 41 sep=/
f31a522a
ML
42 while test -n "$url"
43 do
44 case "$url" in
45 ../*)
46 url="${url#../}"
ea640cc6
TR
47 case "$remoteurl" in
48 */*)
49 remoteurl="${remoteurl%/*}"
50 ;;
51 *:*)
52 remoteurl="${remoteurl%:*}"
53 sep=:
54 ;;
55 *)
497ee872 56 die "$(eval_gettext "cannot strip one component off url '\$remoteurl'")"
ea640cc6
TR
57 ;;
58 esac
f31a522a
ML
59 ;;
60 ./*)
61 url="${url#./}"
62 ;;
63 *)
64 break;;
65 esac
66 done
ea640cc6 67 echo "$remoteurl$sep${url%/}"
f31a522a
ML
68}
69
a7b3269c
DA
70#
71# Get submodule info for registered submodules
72# $@ = path to limit submodule list
73#
74module_list()
75{
313ee0d6
NMC
76 git ls-files --error-unmatch --stage -- "$@" |
77 perl -e '
78 my %unmerged = ();
79 my ($null_sha1) = ("0" x 40);
80 while (<STDIN>) {
81 chomp;
82 my ($mode, $sha1, $stage, $path) =
83 /^([0-7]+) ([0-9a-f]{40}) ([0-3])\t(.*)$/;
84 next unless $mode eq "160000";
85 if ($stage ne "0") {
86 if (!$unmerged{$path}++) {
87 print "$mode $null_sha1 U\t$path\n";
88 }
89 next;
90 }
91 print "$_\n";
92 }
93 '
a7b3269c
DA
94}
95
941987a5
LH
96#
97# Map submodule path to submodule name
98#
99# $1 = path
100#
101module_name()
102{
537601ac 103 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
64394e3a 104 sm_path="$1"
fe22e542 105 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
a5099bb4 106 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
537601ac 107 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
1e42258a 108 test -z "$name" &&
64394e3a 109 die "$(eval_gettext "No submodule mapping found in .gitmodules for path '\$sm_path'")"
1e42258a 110 echo "$name"
941987a5 111}
33aa6fff
LH
112
113#
114# Clone a submodule
115#
23a485e3 116# Prior to calling, cmd_update checks that a possibly existing
ecda0723 117# path is not a git repository.
23a485e3 118# Likewise, cmd_add checks that path does not exist at all,
ecda0723
SV
119# since it is the location of a new submodule.
120#
33aa6fff
LH
121module_clone()
122{
64394e3a 123 sm_path=$1
33aa6fff 124 url=$2
d92a3959 125 reference="$3"
7e60407f
JL
126 quiet=
127 if test -n "$GIT_QUIET"
128 then
129 quiet=-q
130 fi
33aa6fff 131
501770e1
FG
132 gitdir=
133 gitdir_base=
64394e3a
RJ
134 name=$(module_name "$sm_path" 2>/dev/null)
135 test -n "$name" || name="$sm_path"
69c30517 136 base_name=$(dirname "$name")
33aa6fff 137
501770e1 138 gitdir=$(git rev-parse --git-dir)
69c30517
JL
139 gitdir_base="$gitdir/modules/$base_name"
140 gitdir="$gitdir/modules/$name"
501770e1
FG
141
142 if test -d "$gitdir"
d92a3959 143 then
64394e3a 144 mkdir -p "$sm_path"
501770e1 145 rm -f "$gitdir/index"
d92a3959 146 else
501770e1 147 mkdir -p "$gitdir_base"
ea115a0d 148 git clone $quiet -n ${reference:+"$reference"} \
64394e3a
RJ
149 --separate-git-dir "$gitdir" "$url" "$sm_path" ||
150 die "$(eval_gettext "Clone of '\$url' into submodule path '\$sm_path' failed")"
501770e1 151 fi
ea115a0d 152
d75219b4 153 a=$(cd "$gitdir" && pwd)/
64394e3a 154 b=$(cd "$sm_path" && pwd)/
4dce7d9b
JS
155 # normalize Windows-style absolute paths to POSIX-style absolute paths
156 case $a in [a-zA-Z]:/*) a=/${a%%:*}${a#*:} ;; esac
157 case $b in [a-zA-Z]:/*) b=/${b%%:*}${b#*:} ;; esac
d75219b4
JL
158 # Remove all common leading directories after a sanity check
159 if test "${a#$b}" != "$a" || test "${b#$a}" != "$b"; then
160 die "$(eval_gettext "Gitdir '\$a' is part of the submodule path '\$b' or vice versa")"
161 fi
162 while test "${a%%/*}" = "${b%%/*}"
163 do
164 a=${a#*/}
165 b=${b#*/}
166 done
167 # Now chop off the trailing '/'s that were added in the beginning
168 a=${a%/}
169 b=${b%/}
170
c5bc42b9
BW
171 # Turn each leading "*/" component into "../"
172 rel=$(echo $b | sed -e 's|[^/][^/]*|..|g')
64394e3a 173 echo "gitdir: $rel/$a" >"$sm_path/.git"
69c30517 174
c5bc42b9 175 rel=$(echo $a | sed -e 's|[^/][^/]*|..|g')
64394e3a 176 (clear_local_git_env; cd "$sm_path" && GIT_WORK_TREE=. git config core.worktree "$rel/$b")
33aa6fff
LH
177}
178
ecda0723
SV
179#
180# Add a new submodule to the working tree, .gitmodules and the index
181#
ec05df35 182# $@ = repo path
ecda0723
SV
183#
184# optional branch is stored in global branch variable
185#
23a485e3 186cmd_add()
ecda0723 187{
5c08dbbd
JH
188 # parse $args after "submodule ... add".
189 while test $# -ne 0
190 do
191 case "$1" in
192 -b | --branch)
193 case "$2" in '') usage ;; esac
194 branch=$2
195 shift
196 ;;
d27b876b
JL
197 -f | --force)
198 force=$1
199 ;;
5c08dbbd 200 -q|--quiet)
2e6a30ef 201 GIT_QUIET=1
5c08dbbd 202 ;;
d92a3959
MT
203 --reference)
204 case "$2" in '') usage ;; esac
205 reference="--reference=$2"
206 shift
207 ;;
208 --reference=*)
209 reference="$1"
210 shift
211 ;;
5c08dbbd
JH
212 --)
213 shift
214 break
215 ;;
216 -*)
217 usage
218 ;;
219 *)
220 break
221 ;;
222 esac
223 shift
224 done
225
ecda0723 226 repo=$1
64394e3a 227 sm_path=$2
ecda0723 228
64394e3a
RJ
229 if test -z "$sm_path"; then
230 sm_path=$(echo "$repo" |
1414e578
JL
231 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
232 fi
233
64394e3a 234 if test -z "$repo" -o -z "$sm_path"; then
ecda0723
SV
235 usage
236 fi
237
ec05df35
ML
238 # assure repo is absolute or relative to parent
239 case "$repo" in
240 ./*|../*)
241 # dereference source url relative to parent's url
242 realrepo=$(resolve_relative_url "$repo") || exit
243 ;;
244 *:*|/*)
245 # absolute url
246 realrepo=$repo
247 ;;
248 *)
497ee872 249 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
ec05df35
ML
250 ;;
251 esac
252
db75ada5
MG
253 # normalize path:
254 # multiple //; leading ./; /./; /../; trailing /
64394e3a 255 sm_path=$(printf '%s/\n' "$sm_path" |
db75ada5
MG
256 sed -e '
257 s|//*|/|g
258 s|^\(\./\)*||
259 s|/\./|/|g
260 :start
261 s|\([^/]*\)/\.\./||
262 tstart
263 s|/*$||
264 ')
64394e3a
RJ
265 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
266 die "$(eval_gettext "'\$sm_path' already exists in the index")"
ecda0723 267
64394e3a 268 if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
d27b876b 269 then
6ff875c5 270 eval_gettextln "The following path is ignored by one of your .gitignore files:
64394e3a 271\$sm_path
6ff875c5 272Use -f if you really want to add it." >&2
d27b876b
JL
273 exit 1
274 fi
275
d4264ca3 276 # perhaps the path exists and is already a git repo, else clone it
64394e3a 277 if test -e "$sm_path"
d4264ca3 278 then
64394e3a 279 if test -d "$sm_path"/.git -o -f "$sm_path"/.git
d4264ca3 280 then
64394e3a 281 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
d4264ca3 282 else
64394e3a 283 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
d4264ca3 284 fi
c2f93917 285
d4264ca3 286 else
d4264ca3 287
64394e3a 288 module_clone "$sm_path" "$realrepo" "$reference" || exit
ea10b60c 289 (
74ae1419 290 clear_local_git_env
64394e3a 291 cd "$sm_path" &&
ea10b60c
BJ
292 # ash fails to wordsplit ${branch:+-b "$branch"...}
293 case "$branch" in
294 '') git checkout -f -q ;;
502dc5b6 295 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
ea10b60c 296 esac
64394e3a 297 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
d4264ca3 298 fi
64394e3a 299 git config submodule."$sm_path".url "$realrepo"
d4264ca3 300
64394e3a
RJ
301 git add $force "$sm_path" ||
302 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
ecda0723 303
64394e3a
RJ
304 git config -f .gitmodules submodule."$sm_path".path "$sm_path" &&
305 git config -f .gitmodules submodule."$sm_path".url "$repo" &&
31991b02 306 git add --force .gitmodules ||
64394e3a 307 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
ecda0723
SV
308}
309
19a31f9c
ML
310#
311# Execute an arbitrary command sequence in each checked out
312# submodule
313#
314# $@ = command to execute
315#
316cmd_foreach()
317{
1d5bec8b
JH
318 # parse $args after "submodule ... foreach".
319 while test $# -ne 0
320 do
321 case "$1" in
322 -q|--quiet)
323 GIT_QUIET=1
324 ;;
15fc56a8
JH
325 --recursive)
326 recursive=1
327 ;;
1d5bec8b
JH
328 -*)
329 usage
330 ;;
331 *)
332 break
333 ;;
334 esac
335 shift
336 done
337
f030c96d
ÆAB
338 toplevel=$(pwd)
339
4dca1aa6
BC
340 # dup stdin so that it can be restored when running the external
341 # command in the subshell (and a recursive call to this function)
342 exec 3<&0
343
a7b3269c 344 module_list |
64394e3a 345 while read mode sha1 stage sm_path
19a31f9c 346 do
64394e3a 347 if test -e "$sm_path"/.git
19a31f9c 348 then
64394e3a
RJ
349 say "$(eval_gettext "Entering '\$prefix\$sm_path'")"
350 name=$(module_name "$sm_path")
15fc56a8 351 (
64394e3a 352 prefix="$prefix$sm_path/"
74ae1419 353 clear_local_git_env
64394e3a
RJ
354 # we make $path available to scripts ...
355 path=$sm_path
356 cd "$sm_path" &&
15fc56a8
JH
357 eval "$@" &&
358 if test -n "$recursive"
359 then
360 cmd_foreach "--recursive" "$@"
361 fi
4dca1aa6 362 ) <&3 3<&- ||
64394e3a 363 die "$(eval_gettext "Stopping at '\$sm_path'; script returned non-zero status.")"
19a31f9c
ML
364 fi
365 done
366}
367
70c7ac22 368#
211b7f19 369# Register submodules in .git/config
70c7ac22
LH
370#
371# $@ = requested paths (default to all)
372#
23a485e3 373cmd_init()
70c7ac22 374{
5c08dbbd
JH
375 # parse $args after "submodule ... init".
376 while test $# -ne 0
377 do
378 case "$1" in
379 -q|--quiet)
2e6a30ef 380 GIT_QUIET=1
5c08dbbd
JH
381 ;;
382 --)
383 shift
384 break
385 ;;
386 -*)
387 usage
388 ;;
389 *)
390 break
391 ;;
392 esac
393 shift
394 done
395
a7b3269c 396 module_list "$@" |
64394e3a 397 while read mode sha1 stage sm_path
70c7ac22 398 do
64394e3a 399 name=$(module_name "$sm_path") || exit
c1c259e2
JL
400
401 # Copy url setting when it is not set yet
2cd9de3e
JL
402 if test -z "$(git config "submodule.$name.url")"
403 then
404 url=$(git config -f .gitmodules submodule."$name".url)
405 test -z "$url" &&
64394e3a 406 die "$(eval_gettext "No url found for submodule path '\$sm_path' in .gitmodules")"
2cd9de3e
JL
407
408 # Possibly a url relative to parent
409 case "$url" in
410 ./*|../*)
411 url=$(resolve_relative_url "$url") || exit
412 ;;
413 esac
414 git config submodule."$name".url "$url" ||
64394e3a 415 die "$(eval_gettext "Failed to register url for submodule path '\$sm_path'")"
c1c259e2
JL
416
417 say "$(eval_gettext "Submodule '\$name' (\$url) registered for path '\$sm_path'")"
2cd9de3e 418 fi
70c7ac22 419
2cd9de3e 420 # Copy "update" setting when it is not set yet
32948425
JH
421 upd="$(git config -f .gitmodules submodule."$name".update)"
422 test -z "$upd" ||
2cd9de3e 423 test -n "$(git config submodule."$name".update)" ||
32948425 424 git config submodule."$name".update "$upd" ||
64394e3a 425 die "$(eval_gettext "Failed to register update mode for submodule path '\$sm_path'")"
70c7ac22
LH
426 done
427}
428
429#
211b7f19 430# Update each submodule path to correct revision, using clone and checkout as needed
70c7ac22
LH
431#
432# $@ = requested paths (default to all)
433#
23a485e3 434cmd_update()
70c7ac22 435{
5c08dbbd 436 # parse $args after "submodule ... update".
98dbe63d 437 orig_flags=
5c08dbbd
JH
438 while test $# -ne 0
439 do
440 case "$1" in
441 -q|--quiet)
2e6a30ef 442 GIT_QUIET=1
5c08dbbd 443 ;;
be4d2c83 444 -i|--init)
d92a3959 445 init=1
be4d2c83 446 ;;
31ca3ac3 447 -N|--no-fetch)
31ca3ac3
FF
448 nofetch=1
449 ;;
9db31bdf
NMC
450 -f|--force)
451 force=$1
452 ;;
ca2cedba 453 -r|--rebase)
32948425 454 update="rebase"
ca2cedba 455 ;;
d92a3959
MT
456 --reference)
457 case "$2" in '') usage ;; esac
458 reference="--reference=$2"
98dbe63d
KB
459 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
460 shift
d92a3959
MT
461 ;;
462 --reference=*)
463 reference="$1"
d92a3959 464 ;;
42b49178 465 -m|--merge)
42b49178
JH
466 update="merge"
467 ;;
b13fd5c1 468 --recursive)
b13fd5c1
JH
469 recursive=1
470 ;;
efc5fb6a
JH
471 --checkout)
472 update="checkout"
473 ;;
5c08dbbd
JH
474 --)
475 shift
476 break
477 ;;
478 -*)
479 usage
480 ;;
481 *)
482 break
483 ;;
484 esac
98dbe63d
KB
485 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
486 shift
5c08dbbd
JH
487 done
488
d92a3959
MT
489 if test -n "$init"
490 then
491 cmd_init "--" "$@" || return
492 fi
493
1b4735d9 494 cloned_modules=
15ffb7cd
FG
495 module_list "$@" | {
496 err=
64394e3a 497 while read mode sha1 stage sm_path
70c7ac22 498 do
313ee0d6
NMC
499 if test "$stage" = U
500 then
64394e3a 501 echo >&2 "Skipping unmerged submodule $sm_path"
313ee0d6
NMC
502 continue
503 fi
64394e3a 504 name=$(module_name "$sm_path") || exit
5be60078 505 url=$(git config submodule."$name".url)
efc5fb6a
JH
506 if ! test -z "$update"
507 then
508 update_module=$update
509 else
510 update_module=$(git config submodule."$name".update)
511 fi
512
513 if test "$update_module" = "none"
514 then
64394e3a 515 echo "Skipping submodule '$sm_path'"
efc5fb6a
JH
516 continue
517 fi
518
211b7f19 519 if test -z "$url"
70c7ac22
LH
520 then
521 # Only mention uninitialized submodules when its
522 # path have been specified
523 test "$#" != "0" &&
64394e3a 524 say "$(eval_gettext "Submodule path '\$sm_path' not initialized
1c2ef66f 525Maybe you want to use 'update --init'?")"
211b7f19
LH
526 continue
527 fi
528
64394e3a 529 if ! test -d "$sm_path"/.git -o -f "$sm_path"/.git
211b7f19 530 then
64394e3a 531 module_clone "$sm_path" "$url" "$reference"|| exit
1b4735d9 532 cloned_modules="$cloned_modules;$name"
bf2d8246
LH
533 subsha1=
534 else
64394e3a 535 subsha1=$(clear_local_git_env; cd "$sm_path" &&
5be60078 536 git rev-parse --verify HEAD) ||
64394e3a 537 die "$(eval_gettext "Unable to find current revision in submodule path '\$sm_path'")"
70c7ac22 538 fi
211b7f19 539
70c7ac22
LH
540 if test "$subsha1" != "$sha1"
541 then
9db31bdf
NMC
542 subforce=$force
543 # If we don't already have a -f flag and the submodule has never been checked out
544 if test -z "$subsha1" -a -z "$force"
b9b378a0 545 then
9db31bdf 546 subforce="-f"
b9b378a0 547 fi
31ca3ac3
FF
548
549 if test -z "$nofetch"
550 then
e5f522d6
JL
551 # Run fetch only if $sha1 isn't present or it
552 # is not reachable from a ref.
64394e3a 553 (clear_local_git_env; cd "$sm_path" &&
f5799e05 554 ( (rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
e5f522d6 555 test -z "$rev") || git-fetch)) ||
64394e3a 556 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
31ca3ac3
FF
557 fi
558
1b4735d9
SO
559 # Is this something we just cloned?
560 case ";$cloned_modules;" in
561 *";$name;"*)
562 # then there is no local change to integrate
563 update_module= ;;
564 esac
565
877449c1 566 must_die_on_failure=
32948425
JH
567 case "$update_module" in
568 rebase)
569 command="git rebase"
64394e3a
RJ
570 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$sm_path'")"
571 say_msg="$(eval_gettext "Submodule path '\$sm_path': rebased into '\$sha1'")"
877449c1 572 must_die_on_failure=yes
32948425 573 ;;
42b49178
JH
574 merge)
575 command="git merge"
64394e3a
RJ
576 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$sm_path'")"
577 say_msg="$(eval_gettext "Submodule path '\$sm_path': merged in '\$sha1'")"
877449c1 578 must_die_on_failure=yes
42b49178 579 ;;
32948425 580 *)
9db31bdf 581 command="git checkout $subforce -q"
64394e3a
RJ
582 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$sm_path'")"
583 say_msg="$(eval_gettext "Submodule path '\$sm_path': checked out '\$sha1'")"
32948425
JH
584 ;;
585 esac
70c7ac22 586
64394e3a 587 if (clear_local_git_env; cd "$sm_path" && $command "$sha1")
15ffb7cd 588 then
ff968f03 589 say "$say_msg"
877449c1
JH
590 elif test -n "$must_die_on_failure"
591 then
ff968f03 592 die_with_status 2 "$die_msg"
15ffb7cd 593 else
ff968f03 594 err="${err};$die_msg"
877449c1 595 continue
15ffb7cd 596 fi
70c7ac22 597 fi
b13fd5c1
JH
598
599 if test -n "$recursive"
600 then
64394e3a 601 (clear_local_git_env; cd "$sm_path" && eval cmd_update "$orig_flags")
15ffb7cd
FG
602 res=$?
603 if test $res -gt 0
604 then
64394e3a 605 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
15ffb7cd
FG
606 if test $res -eq 1
607 then
ff968f03 608 err="${err};$die_msg"
15ffb7cd
FG
609 continue
610 else
ff968f03 611 die_with_status $res "$die_msg"
15ffb7cd
FG
612 fi
613 fi
b13fd5c1 614 fi
70c7ac22 615 done
15ffb7cd
FG
616
617 if test -n "$err"
618 then
619 OIFS=$IFS
620 IFS=';'
621 for e in $err
622 do
623 if test -n "$e"
624 then
625 echo >&2 "$e"
626 fi
627 done
628 IFS=$OIFS
629 exit 1
630 fi
631 }
70c7ac22
LH
632}
633
bffe71f4
EM
634set_name_rev () {
635 revname=$( (
74ae1419 636 clear_local_git_env
bffe71f4 637 cd "$1" && {
5be60078
JH
638 git describe "$2" 2>/dev/null ||
639 git describe --tags "$2" 2>/dev/null ||
f669ac0b
ML
640 git describe --contains "$2" 2>/dev/null ||
641 git describe --all --always "$2"
bffe71f4
EM
642 }
643 ) )
644 test -z "$revname" || revname=" ($revname)"
645}
28f9af5d
PY
646#
647# Show commit summary for submodules in index or working tree
648#
649# If '--cached' is given, show summary between index and given commit,
650# or between working tree and given commit
651#
652# $@ = [commit (default 'HEAD'),] requested paths (default all)
653#
654cmd_summary() {
f2dc06a3 655 summary_limit=-1
d0f64dd4 656 for_status=
1c244f6e 657 diff_cmd=diff-index
f2dc06a3 658
28f9af5d
PY
659 # parse $args after "submodule ... summary".
660 while test $# -ne 0
661 do
662 case "$1" in
663 --cached)
664 cached="$1"
665 ;;
1c244f6e
JL
666 --files)
667 files="$1"
668 ;;
d0f64dd4
PY
669 --for-status)
670 for_status="$1"
671 ;;
f2dc06a3
PY
672 -n|--summary-limit)
673 if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
674 then
675 :
676 else
677 usage
678 fi
679 shift
680 ;;
28f9af5d
PY
681 --)
682 shift
683 break
684 ;;
685 -*)
686 usage
687 ;;
688 *)
689 break
690 ;;
691 esac
692 shift
693 done
bffe71f4 694
f2dc06a3
PY
695 test $summary_limit = 0 && return
696
3deea89c 697 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
28f9af5d
PY
698 then
699 head=$rev
caa9c3ca 700 test $# = 0 || shift
3deea89c
JH
701 elif test -z "$1" -o "$1" = "HEAD"
702 then
14e940d7
JH
703 # before the first commit: compare with an empty tree
704 head=$(git hash-object -w -t tree --stdin </dev/null)
2ea6c2c9 705 test -z "$1" || shift
28f9af5d 706 else
3deea89c 707 head="HEAD"
28f9af5d
PY
708 fi
709
1c244f6e
JL
710 if [ -n "$files" ]
711 then
712 test -n "$cached" &&
b9b9c22f 713 die "$(gettext -- "--cached cannot be used with --files")"
1c244f6e
JL
714 diff_cmd=diff-files
715 head=
716 fi
717
28f9af5d
PY
718 cd_to_toplevel
719 # Get modified modules cared by user
18076502 720 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
e1622bfc 721 sane_egrep '^:([0-7]* )?160000' |
28f9af5d
PY
722 while read mod_src mod_dst sha1_src sha1_dst status name
723 do
724 # Always show modules deleted or type-changed (blob<->module)
725 test $status = D -o $status = T && echo "$name" && continue
726 # Also show added or modified modules which are checked out
727 GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
728 echo "$name"
729 done
730 )
1cb639e6 731
d0f64dd4
PY
732 test -z "$modules" && return
733
18076502 734 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
e1622bfc 735 sane_egrep '^:([0-7]* )?160000' |
1cb639e6
PY
736 cut -c2- |
737 while read mod_src mod_dst sha1_src sha1_dst status name
738 do
739 if test -z "$cached" &&
740 test $sha1_dst = 0000000000000000000000000000000000000000
741 then
742 case "$mod_dst" in
743 160000)
744 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
745 ;;
746 100644 | 100755 | 120000)
747 sha1_dst=$(git hash-object $name)
748 ;;
749 000000)
750 ;; # removed
751 *)
752 # unexpected type
6ff875c5 753 eval_gettextln "unexpected mode \$mod_dst" >&2
1cb639e6
PY
754 continue ;;
755 esac
756 fi
757 missing_src=
758 missing_dst=
759
760 test $mod_src = 160000 &&
30353a40 761 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
1cb639e6
PY
762 missing_src=t
763
764 test $mod_dst = 160000 &&
30353a40 765 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
1cb639e6 766 missing_dst=t
bffe71f4 767
1cb639e6
PY
768 total_commits=
769 case "$missing_src,$missing_dst" in
770 t,)
f62f8212 771 errmsg="$(eval_gettext " Warn: \$name doesn't contain commit \$sha1_src")"
1cb639e6
PY
772 ;;
773 ,t)
f62f8212 774 errmsg="$(eval_gettext " Warn: \$name doesn't contain commit \$sha1_dst")"
1cb639e6
PY
775 ;;
776 t,t)
f62f8212 777 errmsg="$(eval_gettext " Warn: \$name doesn't contain commits \$sha1_src and \$sha1_dst")"
1cb639e6
PY
778 ;;
779 *)
780 errmsg=
781 total_commits=$(
782 if test $mod_src = 160000 -a $mod_dst = 160000
783 then
784 range="$sha1_src...$sha1_dst"
785 elif test $mod_src = 160000
786 then
787 range=$sha1_src
788 else
789 range=$sha1_dst
790 fi
791 GIT_DIR="$name/.git" \
b0e621ad 792 git rev-list --first-parent $range -- | wc -l
1cb639e6 793 )
eed35595 794 total_commits=" ($(($total_commits + 0)))"
1cb639e6
PY
795 ;;
796 esac
797
798 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
799 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
800 if test $status = T
801 then
b3e73449
ÆAB
802 blob="$(gettext "blob")"
803 submodule="$(gettext "submodule")"
1cb639e6
PY
804 if test $mod_dst = 160000
805 then
b3e73449 806 echo "* $name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
1cb639e6 807 else
b3e73449 808 echo "* $name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
1cb639e6
PY
809 fi
810 else
811 echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
812 fi
813 if test -n "$errmsg"
814 then
815 # Don't give error msg for modification whose dst is not submodule
816 # i.e. deleted or changed to blob
817 test $mod_dst = 160000 && echo "$errmsg"
818 else
819 if test $mod_src = 160000 -a $mod_dst = 160000
820 then
f2dc06a3
PY
821 limit=
822 test $summary_limit -gt 0 && limit="-$summary_limit"
1cb639e6 823 GIT_DIR="$name/.git" \
f2dc06a3 824 git log $limit --pretty='format: %m %s' \
1cb639e6
PY
825 --first-parent $sha1_src...$sha1_dst
826 elif test $mod_dst = 160000
827 then
828 GIT_DIR="$name/.git" \
829 git log --pretty='format: > %s' -1 $sha1_dst
830 else
831 GIT_DIR="$name/.git" \
832 git log --pretty='format: < %s' -1 $sha1_src
833 fi
834 echo
835 fi
836 echo
d0f64dd4
PY
837 done |
838 if test -n "$for_status"; then
f17a5d34 839 if [ -n "$files" ]; then
6ff875c5 840 gettextln "# Submodules changed but not updated:"
f17a5d34 841 else
6ff875c5 842 gettextln "# Submodule changes to be committed:"
f17a5d34 843 fi
d0f64dd4
PY
844 echo "#"
845 sed -e 's|^|# |' -e 's|^# $|#|'
846 else
847 cat
848 fi
28f9af5d 849}
70c7ac22 850#
941987a5 851# List all submodules, prefixed with:
70c7ac22
LH
852# - submodule not initialized
853# + different revision checked out
854#
855# If --cached was specified the revision in the index will be printed
856# instead of the currently checked out revision.
857#
858# $@ = requested paths (default to all)
859#
23a485e3 860cmd_status()
70c7ac22 861{
5c08dbbd 862 # parse $args after "submodule ... status".
98dbe63d 863 orig_flags=
5c08dbbd
JH
864 while test $# -ne 0
865 do
866 case "$1" in
867 -q|--quiet)
2e6a30ef 868 GIT_QUIET=1
5c08dbbd
JH
869 ;;
870 --cached)
871 cached=1
872 ;;
64b19ffe
JH
873 --recursive)
874 recursive=1
875 ;;
5c08dbbd
JH
876 --)
877 shift
878 break
879 ;;
880 -*)
881 usage
882 ;;
883 *)
884 break
885 ;;
886 esac
98dbe63d 887 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
5c08dbbd
JH
888 shift
889 done
890
a7b3269c 891 module_list "$@" |
64394e3a 892 while read mode sha1 stage sm_path
70c7ac22 893 do
64394e3a 894 name=$(module_name "$sm_path") || exit
5be60078 895 url=$(git config submodule."$name".url)
64394e3a 896 displaypath="$prefix$sm_path"
313ee0d6
NMC
897 if test "$stage" = U
898 then
899 say "U$sha1 $displaypath"
900 continue
901 fi
64394e3a 902 if test -z "$url" || ! test -d "$sm_path"/.git -o -f "$sm_path"/.git
70c7ac22 903 then
64b19ffe 904 say "-$sha1 $displaypath"
70c7ac22
LH
905 continue;
906 fi
64394e3a
RJ
907 set_name_rev "$sm_path" "$sha1"
908 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
70c7ac22 909 then
64b19ffe 910 say " $sha1 $displaypath$revname"
70c7ac22
LH
911 else
912 if test -z "$cached"
913 then
64394e3a
RJ
914 sha1=$(clear_local_git_env; cd "$sm_path" && git rev-parse --verify HEAD)
915 set_name_rev "$sm_path" "$sha1"
70c7ac22 916 fi
64b19ffe
JH
917 say "+$sha1 $displaypath$revname"
918 fi
919
920 if test -n "$recursive"
921 then
922 (
923 prefix="$displaypath/"
74ae1419 924 clear_local_git_env
64394e3a 925 cd "$sm_path" &&
a7eff1a8 926 eval cmd_status "$orig_args"
64b19ffe 927 ) ||
64394e3a 928 die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
70c7ac22
LH
929 fi
930 done
931}
2327f61e
DA
932#
933# Sync remote urls for submodules
934# This makes the value for remote.$remote.url match the value
935# specified in .gitmodules.
936#
937cmd_sync()
938{
939 while test $# -ne 0
940 do
941 case "$1" in
942 -q|--quiet)
2e6a30ef 943 GIT_QUIET=1
2327f61e
DA
944 shift
945 ;;
946 --)
947 shift
948 break
949 ;;
950 -*)
951 usage
952 ;;
953 *)
954 break
955 ;;
956 esac
957 done
958 cd_to_toplevel
959 module_list "$@" |
64394e3a 960 while read mode sha1 stage sm_path
2327f61e 961 do
64394e3a 962 name=$(module_name "$sm_path")
2327f61e 963 url=$(git config -f .gitmodules --get submodule."$name".url)
baede9f8
JH
964
965 # Possibly a url relative to parent
966 case "$url" in
967 ./*|../*)
968 url=$(resolve_relative_url "$url") || exit
969 ;;
970 esac
971
ccee6086 972 if git config "submodule.$name.url" >/dev/null 2>/dev/null
2327f61e 973 then
0591c0a5 974 say "$(eval_gettext "Synchronizing submodule url for '\$name'")"
ccee6086
JH
975 git config submodule."$name".url "$url"
976
64394e3a 977 if test -e "$sm_path"/.git
ccee6086
JH
978 then
979 (
980 clear_local_git_env
64394e3a 981 cd "$sm_path"
ccee6086
JH
982 remote=$(get_default_remote)
983 git config remote."$remote".url "$url"
984 )
985 fi
2327f61e
DA
986 fi
987 done
988}
70c7ac22 989
5c08dbbd
JH
990# This loop parses the command line arguments to find the
991# subcommand name to dispatch. Parsing of the subcommand specific
992# options are primarily done by the subcommand implementations.
993# Subcommand specific options such as --branch and --cached are
994# parsed here as well, for backward compatibility.
995
996while test $# != 0 && test -z "$command"
70c7ac22
LH
997do
998 case "$1" in
2327f61e 999 add | foreach | init | update | status | summary | sync)
5c08dbbd 1000 command=$1
70c7ac22
LH
1001 ;;
1002 -q|--quiet)
2e6a30ef 1003 GIT_QUIET=1
70c7ac22 1004 ;;
ecda0723
SV
1005 -b|--branch)
1006 case "$2" in
1007 '')
1008 usage
1009 ;;
1010 esac
1011 branch="$2"; shift
1012 ;;
70c7ac22 1013 --cached)
28f9af5d 1014 cached="$1"
70c7ac22
LH
1015 ;;
1016 --)
1017 break
1018 ;;
1019 -*)
1020 usage
1021 ;;
1022 *)
1023 break
1024 ;;
1025 esac
1026 shift
1027done
1028
5c08dbbd
JH
1029# No command word defaults to "status"
1030test -n "$command" || command=status
1031
1032# "-b branch" is accepted only by "add"
1033if test -n "$branch" && test "$command" != add
1034then
ecda0723 1035 usage
5c08dbbd
JH
1036fi
1037
28f9af5d
PY
1038# "--cached" is accepted only by "status" and "summary"
1039if test -n "$cached" && test "$command" != status -a "$command" != summary
5c08dbbd 1040then
70c7ac22 1041 usage
5c08dbbd
JH
1042fi
1043
1044"cmd_$command" "$@"